# DLCS

![npm version](https://img.shields.io/npm/v/dlcs.svg) [![Build Status](https://travis-ci.org/EESimulations/DLCS.svg)](https://travis-ci.org/EESimulations/DLCS)

## Digital Logic Circuit Simulation library in javascript.

Simulate nodes, logic gates, and ICs.

## Install

[NPM](https://www.npmjs.com/package/dlcs)

```
npm install dlcs
```

```javascript
var dlcs = require('dlcs'); 
```

Clientside

```html
<script src="funary.js"></script>
<script src="DLCS.js"></script>
```

## dlcircuit (Main object)

```javascript
var DLCS = require('dlcs');

//The object returned from DLC or DLCSim is dlcircuit
//dlcircuit is the object that forms every gate, node, and IC
var andgate = new DLCS(3,1,2,1);

//Each object contains an output array
//This returns the the output array
andgate.getOutputValues();

//Setting the output array
andgate.setOutputValues([1]);

//Instantaneous simulation of object
//The values will be set and stored until some other operation happens
andgate.simulate();
```

## Example Simple AND gate:

```javascript
var DLCS = require('dlcs');

//New input node
var outputnode = new DLCS(0,0,1,0);

//New AND gate
var andgate = new DLCS(3,1,2,1);

//Output of gates goes to input node
outputnode.addInput(andgate,0,0);

//New output nodes
var inputnode0 = new DLCS(1,2,0,1);
var inputnode1 = new DLCS(1,3,0,1);

//Set single values
inputnode0.setValue(0,0); //0
inputnode1.setValue(1,0); //1

//Connect to AND
andgate.addInput(inputnode0,0,0);
andgate.addInput(inputnode1,0,1);

//Simulation
outputnode.simulate();

//Get results
outputnode.getValue(0); //0
```
